#version 330
layout(triangles) in;
layout(triangle_strip, max_vertices=15) out;
in vec4 vert_Normal[];
in vec2 uvs[];
out vec2 vert_g_uvs;
out vec4 vert_g_Normal;
out vec4 frag_pos;
uniform mat4 mv_Mat;
uniform mat4 projMat;
uniform float time;
float offset = 0.5;
void main() {
	for(int i=0; i<3; ++i){
		gl_Position = projMat*gl_in[i].gl_Position;
		vert_g_Normal = vert_Normal[i];
		vert_g_uvs = uvs[i];
		EmitVertex();
	}
	EndPrimitive();

	return;
	vec4 O = mv_Mat[3];
	vec3 Oax = normalize(vec3(time, sin(time), cos(time)));
	mat4 Orot = mat4(
			cos(time)+Oax.x*Oax.x*(1-cos(time)),Oax.y*Oax.x*(1-cos(time))+Oax.z*sin(time),Oax.z*Oax.x*(1-cos(time))-Oax.y*sin(time),0,
			Oax.y*Oax.x*(1-cos(time))-Oax.z*sin(time),cos(time)+Oax.y*Oax.y*(1-cos(time)),Oax.z*Oax.y*(1-cos(time))+Oax.x*sin(time),0,
			Oax.x*Oax.z*(1-cos(time))+Oax.y*sin(time),Oax.y*Oax.z*(1-cos(time))-Oax.x*sin(time),cos(time)+Oax.z*Oax.z*(1-cos(time)),0,
			0,0,0,1
			);
	
	for(int i=1; i<6; i++) {
		vec4 face_norm = (vert_Normal[0]+vert_Normal[1]+vert_Normal[2])/3.0;
		vec4 off_vec = face_norm*offset*i*(sin(time)+1)*0.5;
		
		vec4 v1 = gl_in[0].gl_Position;
		vec4 v2 = gl_in[1].gl_Position;
		vec4 v3 = gl_in[2].gl_Position;
		vec4 tr_c = (v1+v2+v3)/3.0;
		vec3 ax = face_norm.xyz;
		float rot_time = time * i;
		mat4 rot = mat4(
			cos(rot_time)+ax.x*ax.x*(1-cos(rot_time)),ax.y*ax.x*(1-cos(rot_time))+ax.z*sin(rot_time),ax.z*ax.x*(1-cos(rot_time))-ax.y*sin(rot_time),0,
			ax.y*ax.x*(1-cos(rot_time))-ax.z*sin(rot_time),cos(rot_time)+ax.y*ax.y*(1-cos(rot_time)),ax.z*ax.y*(1-cos(rot_time))+ax.x*sin(rot_time),0,
			ax.x*ax.z*(1-cos(rot_time))+ax.y*sin(rot_time),ax.y*ax.z*(1-cos(rot_time))-ax.x*sin(rot_time),cos(rot_time)+ax.z*ax.z*(1-cos(rot_time)),0,
			0,0,0,1
			);
		
		gl_Position = projMat * (Orot *(((rot * (v1 - tr_c) + tr_c) + off_vec) - O) + O);
		vert_g_Normal = vert_Normal[0];
		EmitVertex();
		gl_Position = projMat * (Orot *(((rot * (v2 - tr_c) + tr_c) + off_vec) - O) + O);
		vert_g_Normal = vert_Normal[1];
		EmitVertex();
		gl_Position = projMat * (Orot *(((rot * (v3 - tr_c) + tr_c) + off_vec) - O) + O);
		vert_g_Normal = vert_Normal[2];
		EmitVertex();
		EndPrimitive();
	}
}